/*
 * GenericUnixInfo: 一般的なUNIX環境 
 */
 
package environment;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;

public final class GenericUnixInfo extends UnixInfo
{
	//
	// コンストラクタ
	//
	protected GenericUnixInfo()
	{
		super();
	}

	//
	// 再定義メソッド(状態)
	//

	// Swingが利用可能かを返す
	public boolean isSwingAvailable()
	{
		return true;
	}

	// ウィンドウタイトルに使える文字が基本ラテンだけかを返す
	public boolean isWindowTitleBasicLatinOnly()
	{
		return false;
	}

	// アイコン設定の要不要を返す
	public boolean isIconRequired()
	{
		return true;
	}

	// フレームのサイズ変更が可能かを返す
	public boolean isFrameResizable()
	{
		return true;
	}

	// 全画面表示をするかを返す
	public boolean showMainFrameAsFullScreen()
	{
		return false;
	}

	// メインウィンドウ用のサイズを返す
	public Dimension getDefaultMainFrameSize(
		Component component)	// 参照コンポーネント(入力)
	{
		Dimension size = component.getToolkit().getScreenSize();
		return new Dimension(size.width / 3 * 2, size.height / 3 * 2);
	}

	// ウィンドウ用のフォントを返す
	public Font getBaseFont(
		Component component)	// 参照コンポーネント(入力)
	{
		// サイズはポイント指定
		return new Font(super.FONTFACE_DEFAULT, Font.PLAIN, 16);
	}
	
	// メニュー用のフォントを返す
	public Font getMenuFont(
		Component component)	// 参照コンポーネント(入力)
	{
		// 特別なものは指定しない
		return null;
	}

	// マウスの有無を返す
	public boolean hasNoMouse()
	{
		return false;
	}
}
