/*
 * MenuItemDef: メニュー項目定義 
 */

package ui;

import java.awt.event.KeyEvent;

public final class MenuItemDefinition
{
	//
	// クラス属性
	//

	public static final MenuItemDefinition SEPARATOR	= new MenuItemDefinition();

	//
	// 属性
	//
	public final ActionDefinition action;
	public final int mnemonic;
	public final int accelerator;

	//
	// コンストラクタ
	//
	public MenuItemDefinition(
		ActionDefinition ad,
		int nMnemonic)				// ニーモニックのキーコード
	{
		this(ad, nMnemonic, KeyEvent.CHAR_UNDEFINED);
	}
	public MenuItemDefinition(
	ActionDefinition ad,
		int nMnemonic,				// ニーモニックのキーコード
		int nAccellarator)			// ショートカットのキーコード
	{
		if (ad == null) {
			throw new NullPointerException();
		}

		action = ad;
		mnemonic = nMnemonic;
		accelerator = nAccellarator;
	}
	private MenuItemDefinition()
	{
		action = null;
		accelerator = KeyEvent.CHAR_UNDEFINED;
		mnemonic = KeyEvent.CHAR_UNDEFINED;
	}
}
