/*
 * DateHolidayInfo : 日付祝日クラス
 */

public final class DateHolidayInfo extends HolidayInfo {
	//
	// 属性
	//
	private final int day;

	//
	// 構築子
	//

	public DateHolidayInfo(
		String strCountry,	// 国(入力)
		String strName,		// 祝日名(入力)
		int nMonth,		// 月(入力)
		int nDay,			// 日(入力)
		int nDays,			// 日数(入力)
		int nFirstYear,	// 開始年(入力)
		int nLastYear)		// 終了年(入力)
	{
		super(strCountry, strName, nMonth, nDays, nFirstYear, nLastYear);

		if (31 < nDays) {
			throw new IllegalArgumentException();
		}

		day = nDay;
	}

	//
	// 実装
	//

	// 指定年の日付を返す
	protected int getDay(
		int year)	// 日付取得対象年(入力)
	{
		// 年にかかわりなく固定の日付を返す
		return day;
	}
}
