/*
 * WomDowHolidayInfo : 第nm曜日形式祝日クラス
 */

import java.util.Calendar;

public final class WomDowHolidayInfo extends HolidayInfo
{
	//
	// 属性
	//
	private final int weekOfMonth;
	private final int dayOfWeek;

	//
	// 構築子
	//

	public WomDowHolidayInfo(
		String strCountry,	// 国(入力)
		String strName,		// 祝日名(入力)
		int nMonth,		// 月(入力)
		int nWeekOfMonth,	// 週(入力)
		int nDayOfWeek,	// 曜日(入力)
		int nDays,			// 日数(入力)
		int nFirstYear,	// 開始年(入力)
		int nLastYear)		// 終了年(入力)
	{
		super(strCountry, strName, nMonth, nDays, nFirstYear, nLastYear);

		weekOfMonth = nWeekOfMonth;
		dayOfWeek = nDayOfWeek;
	}

	//
	// 実装
	//

	// 指定年の日付を返す
	protected int getDay(
		int year)	// 日付取得対象年
	{
		// 年にかかわりなく固定の日付を返す
		Calendar monthFirstDay = Calendar.getInstance();
		monthFirstDay.set(year, month(), 1);

		final int dayOfWeekOf1st = monthFirstDay.get(Calendar.DAY_OF_WEEK);
		int day = 1;
		if (dayOfWeek < dayOfWeekOf1st) {
			day = weekOfMonth * 7;
		}
		else {
			day = (weekOfMonth - 1) * 7;
		}
		day += (dayOfWeek - dayOfWeekOf1st + 1);

 		return day;
	}
}
