/*
 * MainFrameImp : AWT版メインウィンドウ
 */
package view.awt;

import java.awt.*;
import java.awt.event.ItemListener;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.Map;

import environment.EnvInfo;
import ui.awt.MessageDialog;

import view.ImplementOperation;

public final class MainFrameImp extends Frame
	implements ImplementOperation
{
/*
	//
	// クラス属性
	//
	private static MainFrameImp instance;

	//
	// クラスメソッド
	//

	// 唯一のインスタンスを返す
	public static MainFrameImp getInstance()
	{
		if (instance == null) {
			instance = new MainFrameImp();
		}
		return instance;
	}
*/
	//
	// 属性
	//
	private Choice			yearChoice;
	private Button			saveButton;
	private java.awt.List	holidayList;

	private transient SetYearDialog setYearDialog;

	//
	// 構築子
	//
//	private MainFrameImp()
	public MainFrameImp()
	{
		super();
	}

	//
	// 実装
	//
/*
	// メニューを作成する
	private void createMenu()
	{
		MenuBar menuBar = new MenuBar();
		Object objMenuFont = getToolKit().getDesktopProperty("win.menu.font");
		if (objMenuFont != null && objMenuFont instanceof Font) {
			menuBar.setFont((Font)objMenuFont);
		}

		Menu menuView = new Menu("表示");
		MenuItem itemSetYear = new MenuItem("年の指定...", new MenuShortcut('Y'));
		itemSetYear.addActionListener(this);
		menuView.add(itemSetYear);

		menuBar.add(menuView);
		setMenuBar(menuBar);
	}
*/

	//
	// 再定義メソッド(MainFrameBaseImplementor)
	//

	// コンポーネントを初期化する
	public void initComponent()	// コンポーネント用リソース
	{
		// レイアウトマネージャを設定する
		setLayout(new BorderLayout());

		// ウィンドウ背景色を設定する
		setBackground(SystemColor.menu);
	//	setBackground(SystemColor.scrollbar);
	//	setBackground(SystemColor.inactiveCaption);

		// フォントを設定する
		setFont(EnvInfo.getInstance().getBaseFont(this));

	//	createMenu();

		// 年選択コンボボックスを作成する
		yearChoice = new Choice();

		// 保存ボタンを作成する
		saveButton = new Button();
		saveButton.setLabel("保存");

		// ツールバー風パネルを作成する
		// PanelでなくてもContainerで充分なのでそうする
		// (たぶんWindowsではウィンドウハンドルを消費しないのではないだろうか)
	//	Panel panelControl = new Panel(new FlowLayout(FlowLayout.LEFT));
		Container panelControl = new Container();
		panelControl.setLayout(new FlowLayout(FlowLayout.LEFT));
		panelControl.add(new Label("西暦"));
		panelControl.add(yearChoice);
		panelControl.add(new Label("年の祝祭日"));
		panelControl.add(saveButton);

		// 祝日表示用リストを設定する
		holidayList = new java.awt.List();

		// メインウィンドウに各コントロールを配置する
		add(panelControl, BorderLayout.NORTH);
		add(holidayList, BorderLayout.CENTER);
	}

	// メッセージダイアログを表示する
	public void showMessage(
		String strMessage)	// メッセージ文字列(入力)
	{
		MessageDialog.showReportMessage(this, strMessage);
	}

	//
	// 再定義メソッド(ImplementOperation)
	//

	// 選択されている年を文字列のまま返す
	public String getSelectedYearValue()
	{
		return yearChoice.getSelectedItem();
	}

	// 祝日テキスト保存ファイル名を取得して返す
	public String getSaveFileFullPath(
		String strDialogTitle,	// ダイアログのタイトル
		String strDefPath,		// デフォルトの保存パス
		String strDefFileName)	// デフォルトのファイル名
	{
		String strSavePath = null;

		FileDialog fileDialog = new FileDialog(this,
												strDialogTitle,
												FileDialog.SAVE);
		fileDialog.setDirectory(strDefPath);
		fileDialog.setFile(strDefFileName);
		fileDialog.show();
		if (fileDialog.getFile() != null) {
			strSavePath = fileDialog.getDirectory() + fileDialog.getFile();
		}
		return strSavePath;
	}

	// 年選択イベントリスナーを設定する
	public void setYearChoiceListener(
		ItemListener listener)	// (入力)
	{
		yearChoice.addItemListener(listener);
	}

	// 保存イベントリスナーを設定する
	public void setSaveListener(
		ActionListener listener)	// (入力)
	{
		saveButton.addActionListener(listener);
	}

	// 年選択リストを設定する
	public void setYearList(
		java.util.List yearList,	// 選択年リスト(入力)
		int nYear)					// 選択年(入力)
	{
		yearChoice.removeAll();
		Iterator it = yearList.iterator();
		while (it.hasNext()) {
			yearChoice.add((String)it.next());
		}
		yearChoice.select(Integer.toString(nYear));
	}

	// 年を設定する
	public void setYear(
		int nSetYear)	// 設定年(入力)
	{
		String setYearString = Integer.toString(nSetYear);

		int itemCount = yearChoice.getItemCount();
		int index = 1;
		while (index < itemCount) {
			int year = Integer.parseInt(yearChoice.getItem(index));
			if (year == nSetYear) {
				break;
			}
			else if (nSetYear < year) {
				yearChoice.insert(setYearString, index);
				break;
			}
			index++;
		}
		if (index == itemCount) {
			yearChoice.add(setYearString);
		}
		yearChoice.select(setYearString);
	}

	// 祝日リストを設定する
	public void setHolidayList(
		java.util.List holidayTextList)	// 祝日文字列リスト(入力)
	{
		holidayList.setVisible(false);
		holidayList.removeAll();
		Iterator it = holidayTextList.iterator();
		while (it.hasNext()) {
			holidayList.add((String)it.next());
		}
		holidayList.setVisible(true);
	}

	// 年指定ダイアログを表示する
	// 戻り値: 入力された年(-1のときキャンセル)
	public int showSetYearDialog(
		int nCurrentYear)	// 現在年
	{
		if (setYearDialog == null) {
			setYearDialog = new SetYearDialog(this);
		}
		setYearDialog.show();
		return (setYearDialog.isCloseByOk()
				? setYearDialog.getYear()
				: -1);
	}
	
	// 終了準備処理を行う
	public void prepareExit()
	{
		if (setYearDialog != null) {
			setYearDialog.dispose();
		}
	}

	// 追加の状態を返す
	public Map getAdditionalState()
	{
		return null;
	}

	// 追加の状態を設定する
	public void setAdditionalState(
		Map properties)	// 状態プロパティ
	{
	}
}
