/*
 * SetYearDialog : 年指定ダイアログボックス
 */

package view.awt;

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.KeyListener;

public final class SetYearDialogImp extends Dialog
{
	//
	// クラス属性
	//
	private static final Label label;

	//
	// クラス初期化子
	//
	static
	{
		label = new Label("年:");
	}

	//
	// 属性
	//
	private TextField	yearField;
	private Button		OkButton;
	private Button		cancelButton;

	//
	// 構築子
	//

	public SetYearDialogImp(
		Frame owner)	// 親となるフレーム(入力)
	{
		// モーダルにするために第二引数にtrueを指定
		super(owner, true);

		add(label);

		yearField = new TextField(4);
		add(yearField);

		OkButton = new Button(" OK ");
		OkButton.setEnabled(false);
		add(OkButton);

		cancelButton = new Button("取消");
		add(cancelButton);
	}

	//
	// 再定義メソッド(SetYearDialogOperation)
	//

	// 指定年を返す
	public int getYear()
	{
		return Integer.parseInt(yearField.getText());
	}

	// イベントリスナーを設定する
	public void setListener(
		KeyListener keyListener,				// 年入力フィールド用キーリスナー(入力)
		ActionListener okActionListner,			// OKボタン用アクションリスナー(入力)
		ActionListener cancelActionListener)	// キャンセルボタン用アクションリスナー(入力)
	{
		yearField.addKeyListener(keyListener);
		OkButton.addActionListener(okActionListner);
		cancelButton.addActionListener(cancelActionListener);
	}

	// 状態を更新する
	public void updateStatus()
	{
		OkButton.setEnabled(0 < yearField.getText().length());
	}

	// ウィンドウをアクティブ化する
	public void windowActivated()
	{
		OkButton.setEnabled(0 < yearField.getText().length());
		yearField.requestFocus();
	}
}
